#include "standart.h"
//#include <commctrl.h>


#include <dshow.h> 
#include <qedit.h>
#include <atlbase.h> 
#include <initguid.h>

#include <cv.h>
//#include <cvcam.h>
#include <cxcore.h>
#include <highgui.h>
#include <time.h>
#include <iProxyTrans.h>
#include <ProxyTransuids.h>


#pragma comment ( lib, "strmiids.lib" )
//#pragma comment(lib,"highgui.lib" )
#pragma comment(lib,"cv.lib" )
//#pragma comment(lib,"cvcam.lib" )
#pragma comment(lib,"cxcore.lib" )
#pragma comment(lib,"ProxyTrans.lib" )

//#pragma comment(lib,"cvaux.lib" )
//#pragma comment(lib,"cxts.lib" )
//#pragma comment(lib,"ml.lib" )
//#pragma comment(lib,"cvhaartraining.lib" )

#define FRAME_WIDTH		640
#define FRAME_HEIGHT	480
#define FRAME_RATE		15
#define	CAMERA_NAME		"Logitech QuickCam for Notebooks Deluxe"


IplImage		*image1024x512Left, *image1024x512Right, *imageLeft, *imageRight;
CvCapture		*capLeft, *capRight; 
GLuint			texLeft, texRight;
int				iCamCount = 0;
float			coefX, coefY;
char			*FameBufferLeft[FRAME_WIDTH*FRAME_HEIGHT*3];
char			*FameBufferRight[FRAME_WIDTH*FRAME_HEIGHT*3];

ICaptureGraphBuilder2			*pCaptureGraphBuilder;
IGraphBuilder					*pGraphBuilder;

IBaseFilter						*pBaseFilter[2];
IMediaControl					*pMediaControl;
//NullRenderer					*pNullRendererLeft, pNullRendererRight;
IBaseFilter						*pNullRendererFilterLeft, *pNullRendererFilterRight;
IProxyTransform					*pProxyTransLeft, *pProxyTransRight;
IBaseFilter						*pProxyFilterLeft, *pProxyFilterRight;


int		FindMyCaptureDevice(IBaseFilter**, char*, bool);
void	callbackLeftCamera(IplImage*);
void	callbackRightCamera(IplImage*);
HRESULT	SetMediaParameters(IBaseFilter*, int, int, int);
int		initDirectShow(void);
void	deinitDirectShow(void);


int	initDirectShow(void)
{
int				iCameraCount = 0;
HRESULT			hr = S_OK;	

	CoInitialize( NULL ); 

	//  
	if( FAILED( CoCreateInstance( CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, IID_IGraphBuilder, ( void ** )&pGraphBuilder )) )
	{
		MessageBox(NULL, "  FilterGraph  .", "Error",	MB_ICONERROR | MB_OK);
		return iCameraCount;
	}
	//  MediaControl
	if( FAILED( pGraphBuilder->QueryInterface( IID_IMediaControl, ( void ** )&pMediaControl)) )
	{
		MessageBox(NULL, "  MediaControl  .", "Error",	MB_ICONERROR | MB_OK);
		return iCameraCount;
	}

	// 
	//   NullRenderer
	if( FAILED( CoCreateInstance(CLSID_NullRenderer, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void **)&pNullRendererFilterLeft)) )
	{
		MessageBox(NULL, "  NullRenderer  .", "Error",	MB_ICONERROR | MB_OK);
		return iCameraCount;
	}
	//  NullRenderer  GraphBuilder
	if( FAILED( pGraphBuilder->AddFilter(pNullRendererFilterLeft, L"NullRenderer")))
	{
		MessageBox(NULL, "  NullRenderer  GraphBuilder  .", "Error",	MB_ICONERROR | MB_OK);
		return iCameraCount;
	}

	// 
	//   NullRenderer
	if( FAILED( CoCreateInstance(CLSID_NullRenderer, NULL, CLSCTX_INPROC_SERVER, IID_IBaseFilter, (void **)&pNullRendererFilterRight)) )
	{
		MessageBox(NULL, "  NullRenderer  .", "Error",	MB_ICONERROR | MB_OK);
		return iCameraCount;
	}
	//  NullRenderer  GraphBuilder
	if( FAILED( pGraphBuilder->AddFilter(pNullRendererFilterRight, L"NullRenderer")))
	{
		MessageBox(NULL, "  NullRenderer  GraphBuilder  .", "Error",	MB_ICONERROR | MB_OK);
		return iCameraCount;
	}


	// 
	//  ProxyTransform
	if(FAILED(CoCreateInstance(CLSID_ProxyTransform, NULL, CLSCTX_INPROC_SERVER, IID_IProxyTransform, (void**)&pProxyTransLeft)) )
	{
		MessageBox(NULL, "  ProxyTransform  .", "Error",	MB_ICONERROR | MB_OK);
		return iCameraCount ;
	}

	//   ProxyFilter
	if(FAILED(pProxyTransLeft->QueryInterface(IID_IBaseFilter, (void**)&pProxyFilterLeft)))
	{
		MessageBox(NULL, "   ProxyTransform  .", "Error",	MB_ICONERROR | MB_OK);
		return iCameraCount ;
	}

	//     
	if(FAILED(pProxyTransLeft->set_transform((void(*)(void*))callbackLeftCamera, 0)))
	{
		MessageBox(NULL, "     ProxyTransform  .", "Error",	MB_ICONERROR | MB_OK);
		return iCameraCount ;
	}

	if( FAILED( pGraphBuilder->AddFilter(pProxyFilterLeft, L"ProxyTrans")))
	{
		MessageBox(NULL, "  ProxyFilter  GraphBuilder  .", "Error",	MB_ICONERROR | MB_OK);
		return iCameraCount;
	}

	// 
	//  ProxyTransform
	if(FAILED(CoCreateInstance(CLSID_ProxyTransform, NULL, CLSCTX_INPROC_SERVER, IID_IProxyTransform, (void**)&pProxyTransRight)))
	{
		MessageBox(NULL, "  ProxyTransform  .", "Error",	MB_ICONERROR | MB_OK);
		return iCameraCount ;
	}

	//   ProxyFilter
	if(FAILED(pProxyTransRight->QueryInterface(IID_IBaseFilter, (void**)&pProxyFilterRight)))
	{
		MessageBox(NULL, "   ProxyTransform  .", "Error",	MB_ICONERROR | MB_OK);
		return iCameraCount ;
	}

	//     
	if(FAILED(pProxyTransRight->set_transform((void(*)(void*))callbackRightCamera, 0)))
	{
		MessageBox(NULL, "     ProxyTransform  .", "Error",	MB_ICONERROR | MB_OK);
		return iCameraCount ;
	}

	if( FAILED( pGraphBuilder->AddFilter(pProxyFilterRight, L"ProxyTrans")))
	{
		MessageBox(NULL, "  ProxyFilter  GraphBuilder  .", "Error",	MB_ICONERROR | MB_OK);
		return iCameraCount;
	}



	//  CaptureGraphBuilder
	if( FAILED( CoCreateInstance( CLSID_CaptureGraphBuilder2, NULL, CLSCTX_INPROC_SERVER, IID_ICaptureGraphBuilder2, ( void ** )&pCaptureGraphBuilder )) )
	{
		MessageBox(NULL, "  CaptureGraphBuilder  .", "Error",	MB_ICONERROR | MB_OK);
		return iCameraCount;
	}

	if( FAILED( pCaptureGraphBuilder->SetFiltergraph(pGraphBuilder) ))
	{
		MessageBox(NULL, "  CaptureGraphBuilder->SetFiltergraph  .", "Error",	MB_ICONERROR | MB_OK);
		return iCameraCount;
	}

	//         
	iCameraCount = FindMyCaptureDevice(&pBaseFilter[0], CAMERA_NAME, false);
	if( iCameraCount < 1 )
	{
		MessageBox(NULL, "     .", "Error",	MB_ICONERROR | MB_OK);
		return	iCameraCount;
	}

	Sleep(1);


	for (int i=0; i<iCameraCount; i++)
	{
		pGraphBuilder->AddFilter(pBaseFilter[i], L"VideoCaptureFilter");
		SetMediaParameters(pBaseFilter[i], FRAME_WIDTH, FRAME_HEIGHT, FRAME_RATE);
	}
	

	hr = pCaptureGraphBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, pBaseFilter[0], pProxyFilterLeft, pNullRendererFilterLeft);
	hr = pCaptureGraphBuilder->RenderStream(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, pBaseFilter[1], pProxyFilterRight, pNullRendererFilterRight);

	pMediaControl->Run();

	return iCameraCount;
}

void	deinitDirectShow(void)
{
	if (iCamCount>0)
		pMediaControl->Stop();
	
	if(pCaptureGraphBuilder)
		pCaptureGraphBuilder->Release();

	if(pGraphBuilder)
		pGraphBuilder->Release();

	CoUninitialize();
}
void callbackLeftCamera(IplImage* image)
{
	if(image->imageData == NULL)
		return;

	*imageLeft = *image;

	Sleep(40);
}

void callbackRightCamera(IplImage* image)
{
	if(image->imageData == NULL)
		return;

	*imageRight = *image;

	Sleep(40);
}


HRESULT	SetMediaParameters(IBaseFilter *pBaseFilter, int	iWidth, int iHeight, int iFPS)
{
	//int								CapCount, CapSize;
	HRESULT							hResult = S_OK;
	IAMStreamConfig					*pAMStreamConfig;

	hResult = pCaptureGraphBuilder->FindInterface(&PIN_CATEGORY_CAPTURE, &MEDIATYPE_Video, pBaseFilter, IID_IAMStreamConfig,(void**) &pAMStreamConfig);
	if( FAILED( hResult ))
	{
		MessageBox(NULL, "   AMStreamConfig  CaptureGraphBuilder.", "",	MB_ICONERROR | MB_OK);
		return hResult;
	}

	//pAMStreamConfig->GetNumberOfCapabilities(&CapCount, &CapSize);

	AM_MEDIA_TYPE *pMediaType= new AM_MEDIA_TYPE;

	hResult = pAMStreamConfig->GetFormat(&pMediaType);
	if( FAILED( hResult ))
	{
		MessageBox(NULL, "    AM_MEDIA_TYPE.", "",	MB_ICONERROR | MB_OK);
		return hResult;
	}

	//if ( (pMediaType->formattype == FORMAT_VideoInfo) && (pMediaType->cbFormat > sizeof(VIDEOINFOHEADER)) && (pMediaType->pbFormat != NULL))

	VIDEOINFOHEADER *pVideoInfoHeader = (VIDEOINFOHEADER*)pMediaType->pbFormat;
	pVideoInfoHeader->bmiHeader.biWidth = iWidth;//352;
	pVideoInfoHeader->bmiHeader.biHeight = iHeight;//288;
	pVideoInfoHeader->AvgTimePerFrame = 10000000/iFPS;
	pVideoInfoHeader->bmiHeader.biSizeImage = iWidth*iHeight*3;
	pMediaType->lSampleSize = pVideoInfoHeader->bmiHeader.biSizeImage;
	hResult = pAMStreamConfig->SetFormat(pMediaType);

	if( FAILED( hResult ))
		MessageBox(NULL, "    AM_MEDIA_TYPE.", "",	MB_ICONERROR | MB_OK);

	return hResult;
}





int FindMyCaptureDevice(IBaseFilter **pF, char *szFilterName, bool bSwap)
{
	ICreateDevEnum					*pSysDevEnum;
	IMoniker						*pMoniker;
	IPropertyBag					*pProp;
	IEnumMoniker					*pEnumMoniker;
	IBaseFilter						*pFilter; 


	BSTR							bstrName;
	ULONG							cFetched;

	INT								iDevCount = 0;
	IBaseFilter						*pBaseFilterSwap;
	HRESULT							hr = S_OK;	


	
	bstrName = CComBSTR(_T(szFilterName)); 

	hr = CoCreateInstance( CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC_SERVER, IID_ICreateDevEnum, ( void ** )&pSysDevEnum );
	if( FAILED( hr ))
	{
		MessageBox(NULL, "Create SystemDeviceEnum failed.", "Error",	MB_ICONERROR | MB_OK);
		return hr;
	}

	hr = pSysDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory, &pEnumMoniker, 0);

	if( S_OK != hr )
	{
		MessageBox(NULL, "Create CreateClassEnumerator VideoInputDeviceCategory failed.", "Error",	MB_ICONERROR | MB_OK);
		return hr;
	}


	

	while(S_OK == pEnumMoniker->Next(1, &pMoniker, &cFetched))
	{

		pMoniker->BindToStorage(0, 0, IID_IPropertyBag, (void **)&pProp);
		VARIANT varName;
		VariantInit(&varName); // Try to match the friendly name.
		hr = pProp->Read(L"FriendlyName", &varName, 0);
		if (SUCCEEDED(hr) && (wcscmp(bstrName, varName.bstrVal) == 0))
		{
			hr = pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void**)&pFilter);
			
			pF[iDevCount] = pFilter;
			pF[iDevCount]->AddRef(); // Add ref on the way out.
			iDevCount++;
			Sleep(1);
			//break;
		}
		VariantClear(&varName);
		pMoniker = NULL; // Release for the next loop.
	}

	if ( bSwap && (iDevCount == 2) )
	{
		pBaseFilterSwap = pF[0];
		pF[0]			= pF[1];
		pF[1]			= pBaseFilterSwap;
	}
	
	return iDevCount;
}



void	ResizeGLWindow(int WindowWidth, int WindowHeight)
{
	glViewport(0, 0, WindowWidth, WindowHeight);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-2, 2, -2, 2, 20, -20);
	//gluPerspective(20.0,(double)WindowWidth/WindowHeight,0.5,300);
}



void	InitializeGLWindow(void)
{

	//glHint (GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	glDepthFunc(GL_LEQUAL);

	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	//glLightModelf(GL_LIGHT_MODEL_TWO_SIDE,GL_FALSE);

	//glEnable(GL_NORMALIZE);
   //glEnable(GL_AUTO_NORMAL);

	//glEnable(GL_POLYGON_SMOOTH);
	//glShadeModel(GL_SMOOTH);
	glDisable(GL_CULL_FACE);
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	glEnable(GL_COLOR_MATERIAL);

	/*
	GLenum err = glGetError();
	if(err != GL_NO_ERROR)
	{
		MessageBox(NULL, (LPCSTR)gluErrorString(err), "Error",	MB_ICONERROR | MB_OK);
	}
	*/
	//glEnable (GL_DEPTH_TEST);
	glEnable (GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	

	glDisable(GL_DEPTH_TEST);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE);

	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);


	iCamCount = initDirectShow();
		
	image1024x512Left	= cvCreateImage( cvSize(1024, 512), 8, 3 );
	image1024x512Right	= cvCreateImage( cvSize(1024, 512), 8, 3 );

	imageLeft			= cvCreateImage( cvSize(FRAME_WIDTH, FRAME_HEIGHT), 8, 3 );
	imageRight			= cvCreateImage( cvSize(FRAME_WIDTH, FRAME_HEIGHT), 8, 3 );


	glGenTextures(1, &texLeft);	
	glGenTextures(1, &texRight);	

	glBindTexture(GL_TEXTURE_2D, texLeft);							
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);

	glTexImage2D(GL_TEXTURE_2D, 0, 3, image1024x512Left->width, image1024x512Left->height, 0, GL_RGB, GL_UNSIGNED_BYTE, image1024x512Left->imageData);

	glBindTexture(GL_TEXTURE_2D, texRight);							
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);

	glTexImage2D(GL_TEXTURE_2D, 0, 3, image1024x512Right->width, image1024x512Right->height, 0, GL_RGB, GL_UNSIGNED_BYTE, image1024x512Right->imageData);

	GLenum err = glGetError();
	if(err != GL_NO_ERROR)
	{
		MessageBox(NULL, (LPCSTR)gluErrorString(err), "Error",	MB_ICONERROR | MB_OK);
	}

	coefX = (float)FRAME_WIDTH/1024;
	coefY = (float)FRAME_HEIGHT/512;
}








void DeinitializeGLWindow(void)
{
	deinitDirectShow();
	
	cvReleaseImage(&image1024x512Left);
	cvReleaseImage(&image1024x512Right);
	cvReleaseImage(&imageLeft);
	cvReleaseImage(&imageRight);

}



void RedrawGLWindow()
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glPushMatrix();

	//glTranslatef(1.15F, 0.1F, 0.0F);
	glColor4f(1,1,1,0.5);

	glBindTexture(GL_TEXTURE_2D, texLeft);
	glTexSubImage2D (GL_TEXTURE_2D, 0, 0, 0, imageLeft->width, imageLeft->height, GL_BGR_EXT, GL_UNSIGNED_BYTE, imageLeft->imageData);


	glNormal3f( 0.0F,  0.0F, 1.0F);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0F,	coefY);		glVertex3f(-2.0f,   2.0f,	-2.0F);
		glTexCoord2f(coefX, coefY);		glVertex3f( 2.0f,	2.0f,	-2.0F);
		glTexCoord2f(coefX,		0);		glVertex3f( 2.0f,	-2.0f,  -2.0F);
		glTexCoord2f(0.0F,		0);		glVertex3f(-2.0f,	-2.0f,  -2.0F);
	glEnd();


	glColor4f(1,1,1,0.5);

	glBindTexture(GL_TEXTURE_2D, texRight);
	glTexSubImage2D (GL_TEXTURE_2D, 0, 0, 0, imageRight->width, imageRight->height, GL_BGR_EXT, GL_UNSIGNED_BYTE, imageRight->imageData);

	glNormal3f( 0.0F,  0.0F, 1.0F);
	glBegin(GL_QUADS);
		glTexCoord2f(0.0F,	coefY);		glVertex3f(-2.0f,   2.0f,	-2.0F);
		glTexCoord2f(coefX, coefY);		glVertex3f( 2.0f,	2.0f,	-2.0F);
		glTexCoord2f(coefX,		0);		glVertex3f( 2.0f,	-2.0f,  -2.0F);
		glTexCoord2f(0.0F,		0);		glVertex3f(-2.0f,	-2.0f,  -2.0F);
	glEnd();
	
	glPopMatrix();


	glFlush();
	Sleep(10);
}







